<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.text.SimpleDateFormat"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String today = new SimpleDateFormat("yyyyMMdd").format(new Date());
	final String name = request.getParameter("name");
%>
<base:page type="default" >
<base:head scripts="ajax.js,tabcontrol.js" styles="path.css,toolbar.css,tabcontrol.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;
var selectedSample;
var heGlass;

var disableModificationCheck = false;

var SCORES = ['ScoreInvasiveCancer', 'ScoreInsituCancer', 'ScoreLymphocytes', 'ScoreNormal', 'ScoreStroma', 'ScoreFat'];
var FIELDS = ['score_invasive_cancer', 'score_insitu_cancer', 'score_lymphocytes', 'score_normal', 'score_stroma', 'score_fat'];

function init()
{
	var frm = document.forms['reggie'];
	
	var glassName = '<%=HTML.javaScriptEncode(name)%>'
	heGlass = getHeGlassForScoring(glassName);
	
	if (heGlass != null && heGlass.length > 0)
	{
		// Generate HE glass HTML
		var html = '';
		for (var glassNo = 0; glassNo < heGlass.length; glassNo++)
		{
			var glass = heGlass[glassNo];
			html += createHeGlassSection(glass);
		}
		setInnerHTML('he-glass-container', html);
		Main.show('he-glass-container');
		
		// Fill form with know information
		var firstGoodSample;
		for (var glassNo = 0; glassNo < heGlass.length; glassNo++)
		{
			var glass = heGlass[glassNo];
			for (var sampleNo = 0; sampleNo < glass.samples.length; sampleNo++)
			{
				var sample = glass.samples[sampleNo];
				
				saveOriginalProperties(sample);
				restoreFromLocalStorage(sample);
				
				// Save ID of HE glass since we need that later
				sample.heGlassId = glass.id;
				
				// Save the first GoodStain sample so we can select it later
				if (sample.GoodStain)
				{
					if (firstGoodSample == null) firstGoodSample = sample;
				}
				
				// Calculate sum of scores
				var total = calculateTotalScore(sample);
				
				// Generate text inside table cell
				var html = '<div class="sample-name">'+sample.name.replace(/\.he\d+$/, '')+'</div>';
				html += '<div class="progress" id="'+sample.id+'.progress">' + total + '%</div>';
				
				var td = document.getElementById(sample.heGlassId+'-'+sample.well.location);
				td.innerHTML = html;
				td.sample = sample;
				setSampleClassName(sample);
				
				td.addEventListener('click', sampleOnClick, false);
			}
		}
		
		if (firstGoodSample != null)
		{
			Main.show('score-container');
			selectSample(firstGoodSample);
		}
		Main.show('gocreate');
		window.addEventListener('beforeunload', confirmIfModified);
		
		keepSessionAlive('<%=ID%>', debug && false, '../');
	}
	else
	{
		var msg;
		if (glassName)
		{
			msg = 'Could not find HE glass with name: ' + Main.encodeTags(glassName);
		}
		else
		{
			msg = 'No HE glass available for scoring.';
			msg += ' Specify HE glass name above to re-score.';
		}
		setInnerHTML('he-glass-container', '<div class="messagecontainer note">'+msg+'</div>');
		Main.show('he-glass-container');
	}
	
	// Wait a second until loading uncompleted HE glass
	setTimeout(loadUncompletedHeGlass, 1000);
	
}

/**
	Remember the original properties so that we know if
	a sample has been modified.
*/
function saveOriginalProperties(sample)
{
	var o = {};
	for (var i = 0; i < SCORES.length; i++)
	{
		var p = SCORES[i];
		o[p] = sample[p];	
	}
	
	o.GoodStain = sample.GoodStain;
	o.ScoreComplete = sample.ScoreComplete;
	o.comments = sample.comments;
	sample.o = o;
	sample.isModified = false;
}

/**
	Check if a sample has been modified.
*/
function isModified(sample, useCache)
{
	if (!useCache)
	{
		var o = sample.o;
		sample.isModified = false;
		for (var p in o)
		{
			if (o[p] != sample[p])
			{
				sample.isModified = true;
				break;
			}
		}
	}
	return sample.isModified;
}

function findHeGlass(glassName, autoFind)
{
	var frm = document.forms['reggie'];
	if (!glassName && autoFind != true)
	{
		glassName = frm.findGlassName.value;
		if (!glassName) return;
		
		if (glassName.match(/^\d+$/))
		{
			while (glassName.length < 5)
			{
				glassName = '0'+glassName;
			}
			glassName = 'HE'+glassName;
		}
	}
	var url =  '<%=home%>/sampleproc/histology_score.jsp?ID=<%=ID%>';
	if (glassName)
	{
		url += '&name='+encodeURIComponent(glassName);
	}
	
	location.replace(url);
}

function selectHeGlass()
{
	if (!confirmIfModified()) return;
	
	var url = getRoot() + 'biomaterials/bioplates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
	url += '&resetTemporary=1';
	url += '&tmpfilter:STRING:name='+encodeURIComponent('HE%');
	url += '&callback=setSelectedHeGlass'
	Main.openPopup(url, 'SelectHeGlass', 1050, 700);
}

function setSelectedHeGlass(id, name)
{
	disableModificationCheck = true;
	findHeGlass(name);
}

function getHeGlassForScoring(glassName)
{
	var frm = document.forms['reggie'];	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		var msg = glassName ? 'Finding HE glass: '+Main.encodeTags(glassName) : 'Loading next HE glass for scoring...';
		showLoadingAnimation(msg);
		var url = '../Histology.servlet?ID=<%=ID%>&cmd=GetHeGlassToScore';
		if (glassName)
		{
			url += '&name='+encodeURIComponent(glassName);
		}
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.heGlasses;
}


function createHeGlassSection(glass)
{
	var html = '';
	html += '<div class="he-glass">';
	
	html += '<div class="he-name">' + Main.encodeTags(glass.name || '') + '</div>';
	
	html += '<div class="he-info">';
	html += '<span class="he-tray">' +  Main.encodeTags(glass.tray || '') + '</span>; <span class="he-position">' + Main.encodeTags(glass.position || '') + '</span>';
	html += '<div class="he-comment">' + Main.encodeTags(glass.comments || '') + '</div>';
	html += '</div>';
	
	html += '<table class="he-table">';
	html += '<tr>';
	html += '<td class="not-used" id="'+glass.id+'-A1"></td>';
	html += '<td class="not-used" id="'+glass.id+'-A2"></td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td class="not-used" id="'+glass.id+'-B1"></td>';
	html += '<td class="not-used" id="'+glass.id+'-B2"></td>';
	html += '</tr>';
	html += '<tr>';
	html += '<td class="not-used" id="'+glass.id+'-C1"></td>';
	html += '<td class="not-used" id="'+glass.id+'-C2"></td>';
	html += '</tr>';
	html += '</table>';
	html += '</div>';

	return html;
	
}

function setSampleClassName(sample)
{
	var className = 'used';
	if (sample.GoodStain)
	{
		className += ' good-stain';
	}
	else
	{
		if (getGoodStainedSampleForLocation(sample.well.location) == null)
		{
			className += ' flag';
		}
	}
	
	if (sample.ScoreTotal == null)
	{
		className += ' score-none';
	}
	else if (sample.ScoreTotal != 100 || !sample.ScoreComplete)
	{
		className += ' score-incomplete';
	}
	else
	{
		className += ' score-complete';
	}
	
	if (isModified(sample))
	{
		className += ' modified';
	}
	
	if (selectedSample && selectedSample.id == sample.id)
	{
		className += ' selected';
	}
	
	var td = document.getElementById(sample.heGlassId+'-'+sample.well.location);
	td.className = className;
}

function getGoodStainedSampleForLocation(location)
{
	// Find sample on given location that has GoodStain annotation
	for (var glassNo = 0; glassNo < heGlass.length; glassNo++)
	{
		var glass = heGlass[glassNo];
		for (var sampleNo = 0; sampleNo < glass.samples.length; sampleNo++)
		{
			var sample = glass.samples[sampleNo];
			if (sample.well.location == location && sample.GoodStain)
			{
				return sample;
			}
		}
	}
	return null;
}

function selectSample(sample)
{
	var frm = document.forms['reggie'];
	
	// Sample name
	setInnerHTML('sample.name', sample.name);
	
	// Scores
	for (var i = 0; i < SCORES.length; i++)
	{
		frm[FIELDS[i]].value = sample[SCORES[i]];
	}
	
	// Total score + score complete
	var total = calculateTotalScore(sample);
	setInnerHTML('score_total', total);
	if (total == 100)
	{
		if (sample.numNullScores == 0)
		{
			frm.score_complete.disabled = false;
			frm.score_complete.checked = sample.ScoreComplete;
			setInputStatus('score_total', '', 'valid');
		}
		else
		{
			frm.score_complete.disabled = true;
			frm.score_complete.checked = false;
			setInputStatus('score_total', 'Enter 0 in empty fields to complete scoring', 'warning');
		}
	}
	else
	{
		frm.score_complete.disabled = true;
		frm.score_complete.checked = false;
		setInputStatus('score_total', 'Not 100%', 'warning');
	}
	
	// Good stain
	if (sample.GoodStain)
	{
		frm.good_stain.checked = true;
	}
	else
	{
		frm.good_stain.checked = false;
	}
	
	// Comments
	frm.comments.value = sample.comments || '';
	
	// Class name of selected table cell
	if (selectedSample != null)
	{
		var td = document.getElementById(selectedSample.heGlassId+'-'+selectedSample.well.location);
		Main.removeClass(td, ' selected');
	}
	
	selectedSample = sample;
	setSampleClassName(sample);
	
	frm.score_invasive_cancer.focus();
}

function sampleOnClick(event)
{
	var td = event.currentTarget;
	selectSample(td.sample);
}

function checkScores()
{
	var frm = document.forms['reggie'];

	for (var i = 0; i < SCORES.length; i++)
	{
		selectedSample[SCORES[i]] = toScore(frm[FIELDS[i]].value);
	}
	
	var oldTotal = selectedSample.ScoreTotal;
	var oldNumNull = selectedSample.numNullScores;
	
	var total = calculateTotalScore(selectedSample);
	
	setInnerHTML('score_total', total);
	setInnerHTML(selectedSample.id+'.progress', total + '%');
	
	if (total == 100)
	{
		if (selectedSample.numNullScores == 0)
		{
			// All scores have been entered
			frm.score_complete.disabled = false;
			if (oldTotal != total || oldNumNull != selectedSample.numNullScores)
			{
				// Only check the 'Score complete' if value has changed
				frm.score_complete.checked = true;
				selectedSample.ScoreComplete = true;
			}
			setInputStatus('score_total', '', 'valid');
		}
		else
		{
			frm.score_complete.disabled = true;
			frm.score_complete.checked = false;
			selectedSample.ScoreComplete = false;
			setInputStatus('score_total', 'Enter 0 in empty fields to complete scoring', 'warning');
		}
	}
	else
	{
		frm.score_complete.disabled = true;
		frm.score_complete.checked = false;

		setInputStatus('score_total', 'Not 100%', 'warning');
		selectedSample.ScoreComplete = selectedSample.ScoreTotal == null ? null : false;
	}

	setSampleClassName(selectedSample);
	saveToLocalStorage(selectedSample);
}

function calculateTotalScore(sample)
{
	var total = 0;
	var numNull = 0;
	for (var i = 0; i < SCORES.length; i++)
	{
		var score = sample[SCORES[i]];
		total += sumScore(score);
		if (score == null) numNull++;
	}
	// Set summed total, null only if all values are null
	sample.ScoreTotal = total == 0 && numNull == SCORES.length ? null : total;
	sample.numNullScores = numNull;
	return total;
}

function toScore(value)
{
	var score = parseInt(value);
	return isNaN(score) ? null : score;
}

function sumScore(score)
{
	return score || 0;
}

function scoreCompleteOnClick()
{
	var frm = document.forms['reggie'];
	selectedSample.ScoreComplete = frm.score_complete.checked;
	setSampleClassName(selectedSample);
	saveToLocalStorage(selectedSample);
}

function goodStainOnClick()
{
	var frm = document.forms['reggie'];
	
	var goodSample = getGoodStainedSampleForLocation(selectedSample.well.location);
	if (goodSample != null && goodSample != selectedSample)
	{
		// Reset the current GoodStain sample
		goodSample.GoodStain = null;
		saveToLocalStorage(goodSample);
	}
	
	selectedSample.GoodStain = frm.good_stain.checked ? true : null;
	saveToLocalStorage(selectedSample);
	
	// Repaint samples on current location
	for (var glassNo = 0; glassNo < heGlass.length; glassNo++)
	{
		var glass = heGlass[glassNo];
		
		for (var sampleNo = 0; sampleNo < glass.samples.length; sampleNo++)
		{
			var sample = glass.samples[sampleNo];
			if (sample.well.location == selectedSample.well.location)
			{
				setSampleClassName(sample);
			}
		}
	}
}

function commentsOnBlur()
{
	var frm = document.forms['reggie'];
	selectedSample.comments = frm.comments.value;
	setSampleClassName(selectedSample);
	saveToLocalStorage(selectedSample);
}

function loadUncompletedHeGlass()
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		//showLoadingAnimation('Loading next HE glass for scoring...');
		var url = '../Histology.servlet?ID=<%=ID%>&cmd=GetUncompletedHeGlass';
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status == 'ok')
	{
		var uncompleted = response.heGlasses;
		
		if (uncompleted.length > 0)
		{
			// Populate menu item
			setInnerHTML('uncompletedHeGlass.text', uncompleted.length + ' uncompleted');
			var html = '';	
			for (var glassNo = 0; glassNo < uncompleted.length; glassNo++)
			{
				var glass = uncompleted[glassNo];
			
				html += '<div class="menuitem enabled" id="glass-'+glass.id+'">';
				html += Main.encodeTags(glass.name)+' ('+glass.numUncompleteSamples +')</div>';
			}
			setInnerHTML('select-uncompleted-heglass-menu', html);
			Main.show('uncompletedHeGlass');
		}
		else
		{
			Main.hide('uncompletedHeGlass');
		}
	}
}

function showUncompletedHeGlassMenu(event)
{
	var menu = document.getElementById('select-uncompleted-heglass');
	menu.style.display = 'block';
	
	var pos = Main.getElementPosition(document.getElementById('uncompletedHeGlass'));
	var x = pos.left;
	var y = pos.top+pos.height;

	menu.style.left = (x)+'px';
	menu.style.top = (y)+'px';
	event.stopPropagation();
}

function uncompletedGlassSelected(event)
{
	findHeGlass(event.target.innerHTML);
}

/**
	Confirm if leaving the page is ok. If no event is passed this method
	is called manually and need to display dialog, otherwise the browser
	is taking care of this automatically.
*/
function confirmIfModified(event)
{
	if (disableModificationCheck) return;
	
	var numModified = 0;
	for (var glassNo = 0; glassNo < heGlass.length; glassNo++)
	{
		var glass = heGlass[glassNo];
		for (var sampleNo = 0; sampleNo < glass.samples.length; sampleNo++)
		{
			var sample = glass.samples[sampleNo];
			if (isModified(sample))
			{
				numModified++;
			}
		}
	}
	
	if (event) 
	{
		if (numModified > 0)
		{
			event.returnValue = 'There are unsaved modifications. Continue?';
			return event.returnValue;
		}
	}
	else
	{
		if (numModified > 0)
		{
			return confirm('There are unsaved modifications. Continue?');
		}
		return true;
	}
	
}

function saveModified()
{
	var samples = [];
	var glassInfo = [];
	
	for (var glassNo = 0; glassNo < heGlass.length; glassNo++)
	{
		var glass = heGlass[glassNo];
		var scoreCompleteForGlass = true;
		for (var sampleNo = 0; sampleNo < glass.samples.length; sampleNo++)
		{
			var sample = glass.samples[sampleNo];
			if (isModified(sample))
			{
				samples[samples.length] = sample;
			}
			
			if (sample.GoodStain && sample.ScoreComplete != true || sample.ScoreComplete == false)
			{
				scoreCompleteForGlass = false;
			}
		}
		
		var tmp = {};
		tmp.id = glass.id;
		tmp.ScoreComplete = scoreCompleteForGlass;
		glassInfo[glassInfo.length] = tmp;
	}
	
	if (samples.length == 0)
	{
		if (!confirm('Nothing has changed! Continue saving?'))
		{
			return;
		}
	}
	
	Main.hide('score-container');
	Main.addClass(document.getElementById('he-glass-container'), 'disabled');
		
	var submitInfo = {};
	submitInfo.samples = samples;
	submitInfo.heGlass = glassInfo;
	
	if (debug) Main.debug(JSON.stringify(submitInfo));			
	var request = Ajax.getXmlHttpRequest();
	
	try
	{
		showLoadingAnimation('Saving...');
		var url = '../Histology.servlet?ID=<%=ID%>&cmd=SaveHeScore';
		request.open("POST", url, false);
		request.setRequestHeader("Content-Type", "application/json");	
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);


	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	// Reset changed properties and remove saved info
	for (var sampleNo = 0; sampleNo < samples.length; sampleNo++)
	{
		var sample = samples[sampleNo];
		saveOriginalProperties(sample);
		setSampleClassName(sample);
		removeFromLocalStorage(sample);
	}

	
	var msg = '<ul>';
	for (var i = 0; i < response.messages.length; i++)
	{
		msg += '<li>' + response.messages[i];
	}
	msg += '</ul>';
	setInnerHTML('done', msg);
	
	Main.show('done');
	Main.show('gonext');
	Main.hide('gocreate');

}


/**
	Save score information to the local storage.
*/
function saveToLocalStorage(sample)
{
	if (window.localStorage && isModified(sample, true))
	{
		var storeKey = getStoreKey(sample);
		window.localStorage.setItem(storeKey, JSON.stringify(sample));
		if (debug)
		{
			Main.debug('saveToLocalStorage: ' + sample.name + '=' + window.localStorage.getItem(storeKey));
		}
	}
}

function removeFromLocalStorage(sample)
{
	if (!window.localStorage) return;
	if (debug) Main.debug('removeFromLocalStorage:' + sample.name);
	window.localStorage.removeItem(getStoreKey(sample));
}

function restoreFromLocalStorage(sample)
{
	if (!window.localStorage) return;
	try
	{
		var stored = window.localStorage.getItem(getStoreKey(sample));
		if (!stored) return;
		
		if (debug) Main.debug(stored);
		var tmp = JSON.parse(stored);
		if (!tmp) return;
		
		// Check that all original scores are the same, or someone has modified
		// this sample from another computer
		for (var p in sample.o)
		{
			if (sample.o[p] != tmp.o[p])
			{
				return;
			}
		}
		
		// Ok, copy stored info to the current sample
		for (var i = 0; i < SCORES.length; i++)
		{
			sample[SCORES[i]] = tmp[SCORES[i]];
		}
		sample.ScoreComplete = tmp.ScoreComplete;
		sample.GoodStain = tmp.GoodStain;
		sample.comments = tmp.comments;
	}
	catch (e)
	{
		Main.debug('Could not load stored information for sample ' + sample.name + ': ' + e);
	}
}

function getStoreKey(sample)
{
	return 'reggie.histology.' + sample.id + '.scoreInfo';
}

</script>
<style>

/* Less wide to make more space for help text */
.stepfields .input
{
	width: 200px;
}

input.score
{
	width: 6em;
	text-align: right;
	padding-right: 4px;
}

#he-glass-container
{
	white-space: nowrap;
	overflow: auto;
}

.he-glass
{
	display: inline-block;
	border: 1px solid #A0A0A0;
	margin: 1em 1em 0.5em 1em;
	width: 20em;
	background: #E8E8E8;
}

.he-name
{
	font-weight: bold; 
	background-color: #E0E0E0; 
	border-bottom: 1px solid #A0A0A0; 
	padding: 0.25em;
}

.he-info
{
	background-color: #FFFFFF; 
	border-bottom: 1px solid #A0A0A0;
	padding: 0.25em;
	height: 5em;
	overflow: auto;
	white-space: normal;
}

.he-tray:before
{
	content: 'Tray: ';
}

.he-position:before
{
	content: 'Position: ';
}

.he-comment
{
	font-style: italic;
}


#score-container
{
	clear: both;
}

.he-table
{
	margin-top: 1em;
	margin-bottom: 1em;
	margin-left: auto;
	margin-right: auto;
	border: 1px solid #A0A0A0;
}

.he-table td
{
	width: 10em;
	height: 10em;
	border: 1px solid #A0A0A0;
	padding: 2px;
	background: #FFFFFF;
	background-position: center center;
	background-repeat: no-repeat;
	vertical-align: top;
	text-align: center;
	font-size: 75%;
	color: #666666;
	cursor: pointer;
}

.he-table td.used:hover
{
	border: 2px solid #2288AA;
	border-radius: 4px;
	padding: 1px;
}

.he-table td.not-used
{
	background-color: #D0D0D0;
	background-image: url('../images/not-used.png');
	cursor: default;
}

.he-table td.selected
{
	background-color: #D8FFFF;
}

.he-table td.good-stain
{
	font-weight: bold;
	color: #000000;
}

.he-table td.good-stain.score-none
{
	background-image: url('../images/score-none.png');
}

.he-table td.good-stain.score-incomplete
{
	background-image: url('../images/score-incomplete.png');
}

.he-table td.good-stain.score-complete
{
	background-image: url('../images/score-complete.png');
}

.he-table td.flag
{
	background-image: url('../images/flag.png');
}

td.modified .sample-name:after
{
	content: ' *';
	color: #2244FF;
}

/* Hide progress by default */
.progress
{
	display: none;
}

/* Show progress for GoodStain or total score > 0 */
td.good-stain .progress, td.score-incomplete .progress, td.score-complete .progress
{
	display: block;
}

td.score-incomplete .progress:before
{
	content: '(';
}
td.score-incomplete .progress:after
{
	content: ')';
}

.score-align
{
	width: 6em; 
	display: inline-block;
	padding: 3px;
	text-align: right;
}

#score_total
{
	background-color: #E8E8E8; 
	font-weight: bold;
	padding-right: 6px;
}

#select-uncompleted-heglass-menu
{
	max-height: 20em;
	overflow: auto;
}

#select-uncompleted-heglass .menuitem
{
	padding-left: 16px;
}

#select-uncompleted-heglass .menuitem:hover
{
	padding-left: 14px;
	background-position: 0px 50%;
}
</style>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register HE glass score" 
		/></p:path>

	<div class="content" onclick="Main.hide('select-uncompleted-heglass')">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>
	
	<div id="select-uncompleted-heglass" class="menu vertical" style="width: 150px; display: none; z-index: 999;"
		onclick="uncompletedGlassSelected(event)">
		<div id="select-uncompleted-heglass-menu"></div>
	</div>
	
	<form name="reggie">
	
	<table class="stepform" id="step.1.section">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">HE glass to score</td>
	</tr>
	<tr>
		<td class="stepfields">
			<tbl:toolbar subclass="bottomborder">
				<tbl:label>
				<input type="text" style="width: 12em;" name="findGlassName" 
					placeholder="Find HE glass" title="Enter a full HE glass name or the last digits in the it's number before the dot"
					onkeypress="if (event.keyCode==13 && this.value) findHeGlass()"
					>
					<base:icon image="<%=home+"/images/gonext.png"%>" onclick="findHeGlass()"></base:icon>
				</tbl:label>
				
			
				<tbl:button 
					title="Select HE glass&hellip;" 
					image="<%=home + "/images/microscope.png"%>" 
					onclick="selectHeGlass()"
					tooltip="Manually select a different HE glass"
				/>

				<tbl:button
					id="uncompletedHeGlass"
					title="Loading..."
					image="mini_scroll_down.png"
					onclick="showUncompletedHeGlassMenu(event)"
					tooltip="This list contain HE glass with partial scores"
				/>

			</tbl:toolbar>
			
			<div id="he-glass-container" style="display: none;">
			</div>
			
			<div style="margin-left: 1em; margin-bottom: 0.5em;">
				<base:icon image="<%=home + "/images/flag.png"%>" /> = No GoodStain sample for that location. 
				The Histology piece will be added to the <i>Flagged histology</i> list.
			</div>

			<div id="score-container" style="display: none;">
				<table style="border-collapse: collapse; width: 100%;">
				<tr valign="top" style="background-color: #E8E8E8; border-top: 1px solid #A0A0A0; border-bottom: 1px solid #A0A0A0;">
					<td class="prompt" style="padding: 0.25em;">Sample</td>
					<td class="input" id="sample.name" style="padding: 0.25em; font-weight: bold;"></td>
					<td class="status"></td>
					<td class="help"></td>
				</tr>
				
				<tr>
					<td class="prompt">GoodStain</td>
					<td class="input"><span class="score-align"><input type="checkbox" name="good_stain" onclick="goodStainOnClick()"
						title="Mark this checkbox to overtake the GoodStain annotation"
						></span></td>
					<td class="status" id="good_stain.status"></td>
					<td class="help" rowspan="2">
						Check to overtake the GoodStain annotation. 
						Disabled if this sample is already annotated.
					</td>
				</tr>
				
				<tr>
					<td class="prompt">Scores</td>
					<td class="input"></td>
					<td class="status"></td>
				</tr>
				<tr>
					<td class="subprompt">Invasive cancer</td>
					<td class="input"><input type="text" class="score" name="score_invasive_cancer"
						onkeypress="focusOnEnter(event, 'score_insitu_cancer'); return Numbers.integerOnly(event)"
						onblur="checkScores()"
						>%</td>
					<td class="status" id="score_invasive_cancer.status"></td>
					<td class="help" rowspan="2">
						Enter the percentage for each cell type. 
						They must sum up to 100% before scoring can be compeleted.
					</td>
				</tr>		

				<tr>
					<td class="subprompt">In situ cancer</td>
					<td class="input"><input type="text" class="score" name="score_insitu_cancer"
						onkeypress="focusOnEnter(event, 'score_lymphocytes'); return Numbers.integerOnly(event)"
						onblur="checkScores()"
						>%</td>
					<td class="status" id="score_insitu_cancer.status"></td>
				</tr>		
				<tr>
					<td class="subprompt">Lymphocytes</td>
					<td class="input"><input type="text" class="score" name="score_lymphocytes"
						onkeypress="focusOnEnter(event, 'score_normal'); return Numbers.integerOnly(event)"
						onblur="checkScores()"
						>%</td>
					<td class="status" id="score_lymphocytes.status"></td>
					<td class="help"></td>
				</tr>		
				<tr>
					<td class="subprompt">Normal</td>
					<td class="input"><input type="text" class="score" name="score_normal"
						onkeypress="focusOnEnter(event, 'score_stroma'); return Numbers.integerOnly(event)"
						onblur="checkScores()"
						>%</td>
					<td class="status" id="score_normal.status"></td>
					<td class="help"></td>
				</tr>		
				<tr>
					<td class="subprompt">Stroma</td>
					<td class="input"><input type="text" class="score" name="score_stroma"
						onkeypress="focusOnEnter(event, 'score_fat'); return Numbers.integerOnly(event)"
						onblur="checkScores()"
						>%</td>
					<td class="status" id="score_stroma.status"></td>
					<td class="help"></td>
				</tr>		
				<tr>
					<td class="subprompt">Fat</td>
					<td class="input"><input type="text" class="score" name="score_fat"
						onkeypress="focusOnEnter(event, 'comments'); return Numbers.integerOnly(event)"
						onblur="checkScores()"
						>%</td>
					<td class="status" id="score_fat.status"></td>
					<td class="help"></td>
				</tr>
				<tr>
					<td class="subprompt" style="font-weight: bold; background-color: #E8E8E8;">Total</td>
					<td class="input" style="padding: 0;"><span class="score-align" id="score_total"></span>%</td>
					<td class="status" id="score_total.status"></td>
					<td class="help"><span class="message" id="score_total.message"></span></td>
				</tr>
				
				<tr>
					<td class="subprompt">Score complete</td>
					<td class="input"><span class="score-align"><input type="checkbox" name="score_complete" 
						onclick="scoreCompleteOnClick()"
						title="Uncheck if scoring is not complete"></span></td>
					<td class="status" id="score_complete.status"></td>
					<td class="help">
						Uncheck if scoring is not complete. Disabled if some scores 
						are missing or the total score is not 100%.
					</td>
				</tr>
				
				<tr>
					<td class="prompt" colspan="3">Comments<br>
						<textarea rows="3" style="width: 97%;" name="comments" onblur="commentsOnBlur()"></textarea>
					</td>
					<td class="help"></td>
				</tr>
				</table>
			</div>		

		</td>
	</tr>
	</table>
	

	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;" /></td>
			<td><base:button id="gonext" title="Next HE glass set" image="<%=home+"/images/gonext.png"%>" onclick="findHeGlass(null, true)" style="display: none;" /></td>
			<td><base:button id="gocreate" title="Save" image="<%=home+"/images/gonext.png"%>" onclick="saveModified()" style="display: none;" /></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>